-- order.e
-- 
-- reorders controls in a window to make ide happy
--
-- i really love recursive routines ;-)

-- subscripts sequence s1 by items of where
-- = s1[where[1]][where[2]] ... [where[length(where)]]
function get_sub(sequence s1, sequence where)
	if length(where) = 1 then
		return s1[where[1]]
	end if
	return get_sub(s1[where[1]], where[2..length(where)])
end function

-- same, but sets the item to s2
function set_sub(sequence s1, sequence where, sequence s2)
	if length(where) = 1 then
		return s1[1..where[1]-1] & {s2} & s1[where[1]+1..length(s1)]
	end if
	return s1[1..where[1]-1] & {set_sub(s1[where[1]], where[2..length(where)], s2)} & s1[where[1]+1..length(s1)]
end function

-- retrieves back the controls
function get_items(sequence s)
	sequence res
	res = {}
	for i=1 to length(s) do
		res &= s[i][1] & get_items(s[i][2])
	end for
	return res
end function
	
global function sort_controls(sequence controls)
	sequence s, x, y
	sequence where
	integer parent
	integer myparent
	
	s = {}
	s &= {{controls[1], {}}}
	where = repeat({}, length(controls))
	where[1] = {1}
	
	for i=2 to length(controls) do
		parent = created_controls[controls[i]][CONTROL_PARENTID]
		myparent = find(parent, controls)
		s = set_sub(s, where[myparent] & 2, get_sub(s, where[myparent] & 2) & {{controls[i],{}}} )
		x = where[myparent]
		y = get_sub(s,where[myparent])
		where[i] = x & 2 & length(y[2])
	end for
	
	return get_items(s)
end function